﻿--[[
Name: Babble-Herbs-2.2
Revision: $Rev: 24674 $
Authors(s): kagaro (sal.scotto@gmail.com)
Website: www.wowace.com
Documentation: http://www.wowace.com/wiki/Babble-Herbs-2.2
SVN: http://svn.wowace.com/root/branch/Babble-2.2/Babble-Herbs-2.2
Dependencies: AceLibrary, AceLocale-2.2
License: MIT
]]

local MAJOR_VERSION = "Babble-Herbs-2.2"
local MINOR_VERSION = tonumber(string.sub("$Revision: 24674 $", 12, -3))

if not AceLibrary then error(MAJOR_VERSION .. " requires AceLibrary") end
if not AceLibrary:HasInstance("AceLocale-2.2") then error(MAJOR_VERSION .. " requires AceLocale-2.2") end

local _, x = AceLibrary("AceLocale-2.2"):GetLibraryVersion()
MINOR_VERSION = MINOR_VERSION * 100000 + x

if not AceLibrary:IsNewVersion(MAJOR_VERSION, MINOR_VERSION) then return end

local BabbleHerbs = AceLibrary("AceLocale-2.2"):new(MAJOR_VERSION)

local herbSkills = {}

BabbleHerbs:RegisterTranslations("enUS", function() return {
	["Peacebloom"] = true,
	["Silverleaf"] = true,
	["Earthroot"] = true,
	["Mageroyal"] = true,
	["Briarthorn"] = true,
	["Swiftthistle"] = true,
	["Stranglekelp"] = true,
	["Bruiseweed"] = true,
	["Wild Steelbloom"] = true,
	["Grave Moss"] = true,
	["Kingsblood"] = true,
	["Liferoot"] = true,
	["Fadeleaf"] = true,
	["Goldthorn"] = true,
	["Khadgar's Whisker"] = true,
	["Wintersbite"] = true,
	["Firebloom"] = true,
	["Purple Lotus"] = true,
	["Wildvine"] = true,
	["Arthas' Tears"] = true,
	["Sungrass"] = true,
	["Blindweed"] = true,
	["Ghost Mushroom"] = true,
	["Gromsblood"] = true,
	["Golden Sansam"] = true,
	["Dreamfoil"] = true,
	["Mountain Silversage"] = true,
	["Plaguebloom"] = true,
	["Icecap"] = true,
	["Bloodvine"] = true,
	["Black Lotus"] = true,
	["Felweed"] = true,
	["Dreaming Glory"] = true,
	["Terocone"] = true,
	["Ancient Lichen"] = true,
	["Blood Thistle"] = true,
	["Mana Thistle"] = true,
	["Netherbloom"] = true,
	["Nightmare Vine"] = true,
	["Ragveil"] = true,
	["Flame Cap"] = true,
	["Fel Lotus"] = true,
	
} end)

BabbleHerbs:RegisterTranslations("koKR", function() return {
	["Peacebloom"] 			= "평온초",
	["Silverleaf"] 			= "은엽수잎",
	["Earthroot"] 			= "뱀뿌리",
	["Mageroyal"] 			= "마법초",
	["Briarthorn"] 			= "찔레가시",
	["Swiftthistle"] 		= "토끼엉겅퀴풀",
	["Stranglekelp"] 		= "갈래물풀",
	["Bruiseweed"] 			= "생채기풀",
	["Wild Steelbloom"] 		= "야생 철쭉",
	["Grave Moss"] 			= "무덤이끼",
	["Kingsblood"] 			= "왕꽃잎풀",
	["Liferoot"] 			= "생명의 뿌리",
	["Fadeleaf"] 			= "미명초잎",
	["Goldthorn"] 			= "황금가시",
	["Khadgar's Whisker"] 		= "카드가의 수염",
	["Wintersbite"] 		= "겨울서리풀",
	["Firebloom"] 			= "화염초",
	["Purple Lotus"] 		= "보라 연꽃",
	["Wildvine"] 			= "야생덩굴",
	["Arthas' Tears"] 		= "아서스의 눈물",
	["Sungrass"] 			= "태양풀",
	["Blindweed"] 			= "실명초",
	["Ghost Mushroom"] 		= "유령버섯",
	["Gromsblood"] 			= "그롬의 피",
	["Golden Sansam"] 		= "황금 산삼",
	["Dreamfoil"] 			= "꿈풀",
	["Mountain Silversage"] 	= "은초롱이",
	["Plaguebloom"] 		= "역병초",
	["Icecap"] 			= "얼음송이",
	["Bloodvine"] 			= "붉은덩굴",
	["Black Lotus"] 		= "검은 연꽃",
	["Felweed"] 			= "지옥풀",
	["Dreaming Glory"] 		= "꿈초롱이",
	["Terocone"] 			= "테로열매",
	["Ancient Lichen"] 		= "고대 이끼",
	["Blood Thistle"] 		= "피 엉겅퀴",
	["Mana Thistle"] 		= "마나 엉겅퀴",
	["Netherbloom"] 		= "황천꽃", --check
	["Nightmare Vine"] 		= "악몽의 덩굴",
	["Ragveil"] 			= "가림막이버섯", --check
	["Flame Cap"] 			= "불꽃송이", --check
	["Fel Lotus"] 			= "지옥 연꽃", --check
	
} end)

BabbleHerbs:RegisterTranslations("deDE", function() return {
	["Peacebloom"] = "Friedensblume",
	["Silverleaf"] = "Silberblatt",
	["Earthroot"] = "Erdwurzel",
	["Mageroyal"] = "Maguskönigskraut",
	["Briarthorn"] = "Wilddornrose",
	["Swiftthistle"] = "Flitzdistel",
	["Stranglekelp"] = "Würgetang",
	["Bruiseweed"] = "Beulengras",
	["Wild Steelbloom"] = "Wildstahlblume",
	["Grave Moss"] = "Grabmoos",
	["Kingsblood"] = "Königsblut",
	["Liferoot"] = "Lebenswurz",
	["Fadeleaf"] = "Blassblatt",
	["Goldthorn"] = "Golddorn",
	["Khadgar's Whisker"] = "Khadgars Schnurrbart",
	["Wintersbite"] = "Winterbiss",
	["Firebloom"] = "Feuerblüte",
	["Purple Lotus"] = "Lila Lotus",
	["Wildvine"] = "Wildranke",
	["Arthas' Tears"] = "Arthas' Tränen",
	["Sungrass"] = "Sonnengras",
	["Blindweed"] = "Blindkraut",
	["Ghost Mushroom"] = "Geisterpilz",
	["Gromsblood"] = "Gromsblut",
	["Golden Sansam"] = "Goldener Sansam",
	["Dreamfoil"] = "Traumblatt",
	["Mountain Silversage"] = "Bergsilberweisling",
	["Plaguebloom"] = "Pestblüte",
	["Icecap"] = "Eiskappe",
	["Bloodvine"] = "Blutrebe",
	["Black Lotus"] = "Schwarzer Lotus",
  ["Felweed"] = "Teufelsgras",
  ["Dreaming Glory"] = "Traumwinde",
  ["Terocone"] = "Terozapfen",
  ["Ancient Lichen"] = "Urflechte",
  ["Blood Thistle"] = "Blutdistel",
  ["Mana Thistle"] = "Manadistel",
  ["Netherbloom"] = "Netherblüte",
  ["Nightmare Vine"] = "Alptraumranke",
  ["Ragveil"] = "Zottelkappe",
  ["Flame Cap"] = "Flammenkappe",
  ["Fel Lotus"] = "Teufelslotus",
} end)

BabbleHerbs:RegisterTranslations("frFR", function() return {
	["Peacebloom"] = "Feuillargent",
	["Silverleaf"] = "Pacifique",
	["Earthroot"] = "Terrestrine",
	["Mageroyal"] = "Mage royal",
	["Briarthorn"] = "Eglantine",
	["Swiftthistle"] = "Chardonnier",
	["Stranglekelp"] = "Etouffante",
	["Bruiseweed"] = "Doulourante",
	["Wild Steelbloom"] = "Aciérite sauvage",
	["Grave Moss"] = "Tombeline",
	["Kingsblood"] = "Sang-royal",
	["Liferoot"] = "Vietérule",
	["Fadeleaf"] = "Pâlerette",
	["Goldthorn"] = "Dorépine",
	["Khadgar's Whisker"] = "Moustache de Khadgar",
	["Wintersbite"] = "Hivernale",
	["Firebloom"] = "Fleur de feu",
	["Purple Lotus"] = "Lotus pourpre",
	["Wildvine"] = "Sauvageonne",
	["Arthas' Tears"] = "Larmes d'Arthas",
	["Sungrass"] = "Soleillette",
	["Blindweed"] = "Aveuglette",
	["Ghost Mushroom"] = "Champignon fantôme",
	["Gromsblood"] = "Gromsang",
	["Golden Sansam"] = "Sansam doré",
	["Dreamfoil"] = "Feuillerêve",
	["Mountain Silversage"] = "Sauge-argent des montagnes",
	["Plaguebloom"] = "Fleur de peste",
	["Icecap"] = "Calot de glace",
	["Bloodvine"] = "Vignesang",
	["Black Lotus"] = "Lotus noir",
	--["Felweed"] = true,
	--["Dreaming Glory"] = true,
	--["Terocone"] = true,
	--["Ancient Lichen"] = true,
	--["Blood Thistle"] = true,
	--["Mana Thistle"] = true,
	--["Netherbloom"] = true,
	--["Nightmare Vine"] = true,
	--["Ragveil"] = true,
	--["Flame Cap"] = true,
	--["Fel Lotus"] = true,
} end)

herbSkills = {
	["Peacebloom"] = 1,
	["Silverleaf"] = 1,
	["Earthroot"]  = 15,
	["Mageroyal"]  = 50,
	["Briarthorn"] = 70,
	["Swiftthistle"] = 0,
	["Stranglekelp"] = 85,
	["Bruiseweed"] = 100,
	["Wild Steelbloom"] = 115,
	["Grave Moss"] = 120,
	["Kingsblood"] = 125,
	["Liferoot"] = 150,
	["Fadeleaf"] = 160,
	["Goldthorn"] = 170,
	["Khadgar's Whisker"] = 185,
	["Wintersbite"] = 195,
	["Firebloom"] = 205,
	["Purple Lotus"] = 210,
	["Wildvine"] = 0,
	["Arthas' Tears"] = 220,
	["Sungrass"] = 230,
	["Blindweed"] = 235,
	["Ghost Mushroom"] = 245,
	["Gromsblood"] = 250,
	["Golden Sansam"] = 260,
	["Dreamfoil"] = 270,
	["Mountain Silversage"] = 280,
	["Plaguebloom"] = 285,
	["Icecap"] = 290,
	["Bloodvine"] = 0,
	["Black Lotus"] = 300,
	["Felweed"] = 300,
	["Dreaming Glory"] = 315,
	["Terocone"] = 325,
	["Ancient Lichen"] = 375,
	["Blood Thistle"] = 0,
	["Mana Thistle"] = 375,
	["Netherbloom"] = 350,
	["Nightmare Vine"] = 365,
	["Ragveil"] = 325,
	["Flame Cap"] = 335,
	["Fel Lotus"] = 0,
}
BabbleHerbs:Debug()
BabbleHerbs:SetStrictness(true)

function BabbleHerbs:GetSkill(herb)
	self:argCheck(herb, 2, "string")
	local skill = herbSkills[herb] or herbSkills[self:HasReverseTranslation(herb) and self:GetReverseTranslation(herb) or false]
	if not skill then
		return nil
	end
	return skill
end

function BabbleHerbs:HasNode(herb)
	self:argCheck(herb, 2, "string")
	local skill = herbSkills[herb] or herbSkills[self:HasReverseTranslation(herb) and self:GetReverseTranslation(herb) or false]
	if not skill then
		return false
	end
	return skill > 0
end

AceLibrary:Register(BabbleHerbs, MAJOR_VERSION, MINOR_VERSION)
BabbleHerbs = nil
